import { parentPort } from 'node:worker_threads';
import chromeLauncher from 'chrome-launcher';
import lighthouse from 'lighthouse';

var _a;
const chromePromise = chromeLauncher.launch({
  chromeFlags: ["--headless", "--no-first-run"]
});
const runLighthouse = async (url, lighthouseRunOpts) => {
  var _a2;
  const chrome = await chromePromise;
  const options = {
    output: "json",
    onlyCategories: lighthouseRunOpts.categories,
    port: chrome.port
  };
  const runnerResult = await lighthouse(url, options);
  (_a2 = parentPort) == null ? void 0 : _a2.postMessage(runnerResult.lhr);
};
(_a = parentPort) == null ? void 0 : _a.on("message", (message) => {
  if (message.type === "runLighthouse") {
    runLighthouse(message.url, message.lighthouseRunOpts);
  } else if (message.type === "close") {
    chromePromise.then((chrome) => chrome.kill()).then(() => process.exit(0));
  }
});
